// Copyright (c) Microsoft Corporation.  All rights reserved.

#include "stdafx.h"
#include "WICBitmap.h"
#include "WICBitmapLock.h"

using namespace Microsoft::WindowsAPICodePack::DirectX::WindowsImagingComponent;
using namespace System::Runtime::InteropServices;

void WICBitmap::SetResolution( BitmapResolution resolution )
{
    CommonUtils::VerifyResult( 
        GetInterface<IWICBitmap>()->SetResolution(resolution.DpiX, resolution.DpiY) );
}

WICBitmapLock^ WICBitmap::Lock(BitmapRectangle lockRectangle, BitmapLockFlags flags)
{
    pin_ptr<BitmapRectangle> rect = &lockRectangle;
    IWICBitmapLock * lock = NULL;

    CommonUtils::VerifyResult( 
        GetInterface<IWICBitmap>()->Lock((WICRect*) rect, static_cast<DWORD>(flags), &lock));

    return lock ? gcnew WICBitmapLock(lock) : nullptr;
}