﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;

namespace PrintDemo
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            FillList();
        }

        private void FillList()
        {
            Process[] processes = Process.GetProcesses();
            foreach (Process proc in processes)
            {
                listViewProcesses.Items.Add(ProcToListViewItem(proc));
            }
        }

        private ListViewItem ProcToListViewItem(Process proc)
        {
            ListViewItem item = new ListViewItem(proc.ProcessName);
            item.SubItems.Add(proc.Id.ToString());
            item.SubItems.Add(proc.WorkingSet64.ToString("N0"));
            item.SubItems.Add(proc.BasePriority.ToString());
            return item;
        }

        private void buttonPrint_Click(object sender, EventArgs e)
        {
            ProcessPrintDocument printDoc = new ProcessPrintDocument(Process.GetProcesses());
            PrintDialog pd = new PrintDialog();
            pd.Document = printDoc;
            pd.UseEXDialog = true;
            
            if (pd.ShowDialog() == DialogResult.OK)
            {
                printDoc.Print();
            }
        }

        private void buttonPrintPreview_Click(object sender, EventArgs e)
        {
            ProcessPrintDocument printDoc = new ProcessPrintDocument(Process.GetProcesses());
            PrintPreviewDialog dlg = new PrintPreviewDialog();
            dlg.Document = printDoc;
            dlg.ShowDialog(this);
        }
    }
}
