﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;

namespace CommandUndo
{
    class MoveCommand : ICommand
    {
        private Size _offset;
        private IWidget _widget;

        public MoveCommand(IWidget widget, Size offset)
        {
            _widget = widget;
            _offset = offset;
        }

        #region ICommand Members

        public void Execute()
        {
            _widget.Move(_offset);
        }

        public void Undo()
        {
            Size negOffset = new Size(-_offset.Width, -_offset.Height);
            _widget.Move(negOffset);
        }

        public string Name
        {
            get { return "Move widget"; }
        }

        #endregion
    }
}
